# file      : build/c/cpp-options.make
# author    : Boris Kolpackov <boris@kolpackov.net>
# copyright : Copyright (c) 2004 Boris Kolpackov
# license   : GNU GPL v2; http://www.gnu.org/licenses/gpl.txt

define c-cpp-options-expand-impl
$(if $1,cat $1 >>$2)
endef

define c-cpp-options-expand
$(call c-cpp-options-expand-impl,$(filter %.cpp-options,$1),$2)
endef

#@@ Asymmetry: I hide creation commands but show removals.
#

define c-cpp-options-force-impl
$(if $(subst $1,,$2)$(subst $2,,$1),FORCE)
endef

define c-cpp-options-force
$(call c-cpp-options-force-impl,$(shell if test -f $1; then exec head -n 1 $1; fi),$2)
endef


$(out_root)/%.cpp-options: $$(call c-cpp-options-force,$$@,$$(value)) | $$(dir $$@).
	@echo "$(value)" >$@
	@$(call c-cpp-options-expand,$^,$@)


# Clean.
#
$(out_root)/%.cpp-options.clean:
	$(call message,rm $(basename $@),rm -f $(basename $@))
