# file      : build/install/install-functions.make
# author    : Boris Kolpackov <boris@kolpackov.net>
# copyright : Copyright (c) 2004 Boris Kolpackov
# license   : GNU GPL v2; http://www.gnu.org/licenses/gpl.txt

#@@ could just call it functions.make
#

define install-exec
$(call message,,$(install_dir) $(dir $2))
	$(call message,install $2,$(install_exec) $1 $2)
endef

define install-lib
$(call message,,$(install_dir) $(dir $2))
	$(call message,install $2,$(value $(if $(patsubst %.so,,$(shell \
sed -e '1q' <$1)),install_data,install_exec)) $(shell sed -e '1q' <$1) $2)
endef


define install-data
$(call message,,$(install_dir) $(dir $2))
	$(call message,install $2,$(install_data) $1 $2)
endef

define install-dir
$(call message,,find $1 $3 -type f -mindepth 1 -printf '%P\n' \
| xargs --no-run-if-empty -n 1 dirname \
| sort -u \
| sed -e 's%\(.*\)%$2/\1%' \
| xargs --no-run-if-empty -n 1 $(install_dir))
	$(call message,install $2/,\
find $1 $3 -type f ! -perm -100 -mindepth 1 -printf '%P\n' \
| sed -e 's%\(.*\)%$1/\1 $2/\1%' \
| xargs --no-run-if-empty -n 2 $(install_data) ; \
find $1 $3 -type f -perm -100 -mindepth 1 -printf '%P\n' \
| sed -e 's%\(.*\)%$1/\1 $2/\1%' \
| xargs --no-run-if-empty -n 2 $(install_exec))
endef
